SystemOrganization addCategory: #IAN_simulation!

PolygonMorph subclass: #IAN_barrier
	instanceVariableNames: 'inField dropRate drMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 23:19'!
drMorph
^drMorph! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 23:19'!
drMorph: aM
drMorph := aM! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:10'!
dropRate: aVal 
"0 to 1"
dropRate := aVal.
self color: ((self color) alpha:  ((aVal * 0.5) + 0.25)). " squeezes visual effect into 0.25-0.75 alpha"
self drMorph contents: ((1 -aVal) asString) .
self changed. 

! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 13:17'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:53'!
hasClock
^false! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:43'!
inField
^inField! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:43'!
inField: aBoolean 
inField := aBoolean! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 23:23'!
initialize 
super initialize .
self inField: false.
dropRate = 0.5 .
self drMorph: (StringMorph new ; contents: (dropRate asString) ).
self addMorphCentered: drMorph! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:06'!
mouseDown: evt
	evt controlKeyPressed
		ifTrue: [ World primaryHand attachMorph: self copy ]
		ifFalse: [ 
			evt shiftPressed
				ifTrue: [ 
					inField
						ifTrue: [ self dropRate: ( 1- (self userValue ))
							] ] ]! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 21:24'!
statDel
| drop |
drop:= ((100 atRandom) < (100* dropRate)).
^drop! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:05'!
userValue
	| inP |
	[ 	inP := CommandLineUIManager default
			textEntry: 'PassRate value 0.0 to 1.0 (0 = drop all)'
			title: 'Packet filter Pass Rate'
			entryText: '0.5'.
		inP ifNil: [ inP := '0.5' ] .
		inP matchesRegex: '(\+)?\d+(\.\d+)?' ] whileFalse.
^ inP asNumber! !

PolygonMorph subclass: #IAN_stateChanger
	instanceVariableNames: 'name target action document myOC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

IAN_stateChanger subclass: #IAN_choice
	instanceVariableNames: 'guard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_choice methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 16:32'!
initialize 
super initialize .
self color: Color lightOrange   .
self extent: (2@2) ; position: self position + (20 atRandom @ 20 atRandom) .
! !

IAN_stateChanger subclass: #IAN_initial
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 10:37'!
action
^action! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 10:36'!
action: aCall 
action := aCall! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 11:14'!
breakActionUp: anAction
| sp tab  temp type selector values|

sp := Character space.
tab := Character tab.
" form of input is type_selector(value,value); "
"first remove whitespaces and colon"

temp := anAction reject: [ :letter | (letter = sp) or: [ (letter = tab)  or: [ letter = $; ] ]  ].

temp := temp findTokens: $_ .
type := temp at: 1.
temp := (temp at: 2) findTokens: {$( . $) } .
selector := temp at: 1.
temp removeFirst . " selector removed"
(temp size > 0) ifTrue: [ values :=( (temp at:1 ) findTokens: $, ) ].  " leaves values as anOC of strings"

^ (Array with: type with: selector with: values)! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 11:13'!
doAction
"doAction decomposes action into an array for doing"
^self breakActionUp: action! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 11:05'!
fillDataWith: anOc

super fillDataWith: anOc.

1 to: (myOC size -2 ) do: [ :indx | action ifNil: [ action := self findIn: myOC at: indx  between: 'action'] ].

! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 11:06'!
findIn: anOC at: index between: aName 
| srt end |

srt :=  (anOC at: index) = (aName asOrderedCollection) .
end := (anOC at: (index +2)) = (('/',aName) asOrderedCollection) .
(srt and: [ end] )
	ifTrue: [ ^String newFrom: ((anOC at: (index +1)) asArray )].
	^nil.! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PGH 2/16/2014 09:58'!
initialize 
super initialize .
self color: Color lightBlue  .



! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/20/2014 16:14'!
myglyph: options 
super myglyph: options color: Color black.! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:29'!
target
^target! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:32'!
yourtitleData: anArray
| args |
args := String newFrom: ((anArray at: 2) asArray ).

target  := (args findTokens: $/ ) collect: [ :e | e asString ].

! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 13:38'!
fillDataWith: anOC 
| my_glyph val i str |
" read strings into inst vars until endOc (=/px) seen "
myOC := anOC.
" lookfor glyph"
str := self className .
"drop IAN_"
str := str copyFrom: ('IAN_' size + 1) to: (str size).
my_glyph := (str,'_glyph')  asOrderedCollection . " example state_glyph"

i := 1.

val :=( myOC at: i) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i) size)).  " step thru top level of ordered collection"

[(val  = my_glyph) or: [ i = (myOC size) ] ] whileFalse: [  val :=( myOC at: (i := i +1) ) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i ) size)) ].

val := myOC at: i . " get full token back"
"found <state_glyph node=aString/>"
" aString is double quted and holds x,y,a,b x,y is start point and a,b is end point "
" find double quote poisitions in collection"

self myglyph: (self varData: val )


! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 17:59'!
myglyph: aValueWeDontCareAbout
"this is overridden by subclasses"! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 09:10'!
myglyph: options color: aColor

| val valS valSe deltaXY myVerts startPoint beginXorY  |

val := options at: 2. "first option is type_name, second is xy data"

deltaXY := OrderedCollection  new .
myVerts := OrderedCollection  new .

valS := String newFrom: val .

valSe := (valS findTokens: $, ) collect: [ :e | e asInteger ].

beginXorY := (valSe at: 3) \\ 2. " a guess?"
startPoint := ((valSe at:1 ) @ (valSe at: 2)) .
deltaXY := valSe copyFrom: 5 to: (valSe size) .

myVerts addLast: startPoint * 4. "crude scale"
deltaXY := deltaXY collect: [ :e | e*4 ].

deltaXY do: [ :aDelta | myVerts addLast: ( myVerts last  + ((aDelta * beginXorY ) @ (aDelta *(1-beginXorY)))). beginXorY := (beginXorY +1) \\2  ].


self vertices: myVerts color: aColor .
self beStraightSegments ; makeForwardArrow ; makeOpen .

self submorphsDo: [  :each | each position: each position - startPoint ].! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:36'!
varData: nx

	| i type val nextsp nextdQ answer reply |

	i := 1.
	answer := OrderedCollection new.
	(nx includes: $=)
		ifTrue: [ 
			i := 1.
			[i = ((nx size) - 1)] whileFalse: [ 
					[ (nx at: i) = (Character space) ] whileFalse: [ i := i + 1 ].
					nextsp := i.
					[ (nx at: i) = $" ] whileFalse: [ i := i + 1 ].
					nextdQ := i.
					type := nx copyFrom: nextsp +1 to: nextdQ - 2.
					[ (nx at:  i + 1) = $" ] whileFalse: [ i := i + 1 ].	"+1 moves over  first doublequote finds next doublequote"
					val := nx copyFrom: nextdQ + 1 to:  i .
					answer addLast: type.
					answer addLast: val.
			 ].
		reply := answer collect: [  :each | each asArray  ].
		^reply
		]
	ifFalse: [  ^Array with: #($n $o $n $e ) with:  #($n $o $n $e ) ].! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 12:50'!
yourtitleData: anArray
"blank for now"! !

IAN_stateChanger subclass: #IAN_tran
	instanceVariableNames: 'trigger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PGH 2/16/2014 09:58'!
initialize 
super initialize .
self color: Color lightMagenta   .



! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/20/2014 16:14'!
myglyph: options 
super myglyph: options color: Color red.! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 17:44'!
name
^name! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 17:44'!
name: aString 
name := aString ! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/24/2014 17:11'!
target
^target! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/24/2014 17:11'!
target: val 
target := val! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:14'!
trigger
 ^trigger! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:14'!
trigger: aBlock
trigger := aBlock! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:35'!
yourtitleData: anArray

|  args  |

trigger := String newFrom: ((anArray at: 2) asArray ).

args := String newFrom: ((anArray at: 4) asArray ). 

target  := (args findTokens: $/ ) collect: [ :e | e asString ]. 
! !

!PolygonMorph methodsFor: '*IAN_simulation' stamp: 'PhilipHunt 2/20/2014 15:10'!
vertices: verts color: aColor 
	vertices := verts.
	color := aColor.
	borderWidth := 1.
	borderColor := aColor.
	closed := vertices size > 2.
	arrows := #none.
	self computeBounds! !

BorderedMorph subclass: #IAN_Node
	instanceVariableNames: 'myName inField counters wiggle myClock flashMorph mySM flashingSchedule leftright hasStates hasStateMach lastBleValueRxed registers running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

IAN_Node subclass: #IAN_CC
	instanceVariableNames: 'myType myENs availableTXers fromEN'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/16/2014 20:36'!
addBackToAvailableTXers: aTXer
availableTXers addLast: aTXer! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/25/2014 11:23'!
addtoMyENs: aNewEN 
| newTXer|

(myENs size < 9) ifTrue: [ 
"first check if the EN is already got a TXer assigned"
(myENs includesKey: aNewEN)  ifFalse: [ 
	newTXer := self getNextAvailableTXer .
	newTXer connPeriodShort .
" add the new transmitter to the CC morph at next position"
	myENs at: aNewEN put: newTXer .
	newTXer target: aNewEN .
	]
" not nil do nothing"	
] ifFalse: [ (self mySM) signal: 'tooManyENs' ] .

! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 14:20'!
bleRx: aMsgOC
" incoming messages are performed here"
" later we might have many receivers but at first this is the switchyard"
| cmd |

" 3 implicit actions"
fromEN := aMsgOC at: 1 .

cmd := aMsgOC at: 2.

(cmd = 'IjoinedYou' ) 		ifTrue: [self addtoMyENs: fromEN  ].
(cmd = 'IunjoinedYou' ) 	ifTrue: [self removeFromMyENs: fromEN ]. 

((aMsgOC size > 2) and: [ (aMsgOC at: 3) isNil not] ) ifTrue: [ lastBleValueRxed := (aMsgOC at: 3) at:1 ]  . " note left as a string"

mySM signal: 'bleRx_',cmd.! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/25/2014 10:16'!
bleTx: inptOC
| anOC endTime |
anOC := OrderedCollection newFrom: inptOC.

(anOC at: 1) = 'joinMe' ifTrue: [ 
	(myENs size =8) ifTrue: [ anOC removeFirst. anOC addFirst:( 'joinFail') ] .
	self sendToFromENmessage: anOC ]
ifFalse: [ 
" special cases"

((anOC at:1) = 'changeConPeriodAll' ) ifTrue: [ 
		anOC removeFirst. anOC addFirst:( 'conPeriodChanged') . 
		self tellAllENs: anOC .
		^anOC ] .

(((anOC at:1) = 'flashTopUntil' ) | ((anOC at:1) = 'flashBotUntil' )  | ((anOC at:1) = 'flashRapUntil' ) ) ifTrue: [ 
	((myENs size) ~= 0) ifTrue: [ 
			endTime := registers at:( (anOC at:2) at: 1) .
			(anOC at:2) at: 1 put: (endTime asString) .
			self tellAllENs: anOC ] .
	^anOC . "if sending an Until message but myENs are empty don't send anything"
	] .

((anOC at:1) = 'changeConPeriodLastEN' ) ifTrue: [ 
		anOC removeFirst. anOC addFirst:( 'conPeriodChanged') . 
		]. "falls thru to regular transmit"
	

	fromEN ifNotNil: [  self sendToEN: fromEN message: anOC ]

	] " ends the false of TXer present test of joinMe"
! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/16/2014 20:55'!
getNextAvailableTXer
| nextTXer |
nextTXer := availableTXers removeFirst.
nextTXer visible: true.
^nextTXer ! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:43'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/24/2014 14:27'!
initialize
|aTXer |
super initialize.
myENs := Dictionary new.
availableTXers := OrderedCollection  new. 
1 to: 8 do: [ :i | 
	aTXer := IAN_bleTxer new .
	aTXer position: (self topLeft  + (8 @ 10 ) negated +  ( ( 56 @ 0)  * (i / 8 )) ).
	aTXer place: i .
	aTXer draw.
	aTXer color: Color lightCyan .
	availableTXers add: aTXer.
	aTXer visible: false.
	self addMorph: aTXer .  ] . 

! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 16:47'!
myENs
^myENs! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:44'!
myType
^ myType! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:44'!
myType: aString 
myType := aString! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 11:07'!
removeFromMyENs: thisEN
| removeTXer |
removeTXer := (myENs at: thisEN). 
removeTXer visible: false.
removeTXer clearTarget .
" but the unJoinMe message needs to leave first"
self addBackToAvailableTXers: removeTXer .
myENs removeKey: thisEN ! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/11/2014 09:37'!
sendToEN: anEN message: inOC 
| aMsgOC |

aMsgOC := OrderedCollection newFrom: inOC .

aMsgOC addFirst: myName .
"load this ens bleTxer with a new message (Txer configures values on send)"

(myENs at: anEN ) send: aMsgOC 
! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/11/2014 13:48'!
sendToFromENmessage: inOC 
| aMsgOC newMessage anEN |

aMsgOC := OrderedCollection newFrom: inOC .

aMsgOC addFirst: myName .
"load this ens bleTxer with a new message (Txer configures values on send)"

" send without using TXer as this is BEFORE join"
	newMessage := IAN_message  new.
	self owner addMorphCentered: newMessage .
	newMessage message: aMsgOC .
	newMessage setBarrierList .
	newMessage startPosition: self center.
	anEN := ((self owner)  submorphs) detect: [ :aM | aM class = IAN_EN and: [ aM myName = fromEN ] ] .
	newMessage targetPosition: anEN center.
	newMessage target: anEN .
	newMessage startStepping ! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/14/2014 11:21'!
tellAllENs: anOC
		self findENs do: [ :anEN | self sendToEN: anEN message: anOC ] .! !

IAN_Node subclass: #IAN_EN
	instanceVariableNames: 'myType myCC myTXer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/25/2014 11:32'!
addToMyCC: aNewCC
	| newTXer |
	myCC := aNewCC.	"record in myCC as this determines targets too in bleTX"
	myTXer
		ifNil: [ 
			newTXer := IAN_bleTxer new.
			newTXer
				color: Color lightCyan;
				extent: 8 @ 8.
			newTXer connPeriodShort.	" add the new transmitter to the EN morph at next position"
			myTXer := newTXer.
			self addMorph: newTXer.
			newTXer position: self topLeft + (0 @ 10) negated.
			newTXer target: aNewCC ]
		ifNotNil: [ 
			myTXer visible: true.
			myTXer target: aNewCC ]! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 11:17'!
bleRx: aMsgOC
" incoming messages are performed here"
" later we might have many receivers but at first this is the switchyard"
| cmd fromCC |

" 3 implicit actions"
fromCC := aMsgOC at: 1 .

cmd := aMsgOC at: 2 .


(cmd = 'joinMe' )	ifTrue: [ self addToMyCC: (fromCC) ].
(cmd = 'conPeriodChange' )   ifTrue:   [(self myTXer)   conn_period: (((aMsgOC at: 3) at: 1 )asInteger )].
	
((aMsgOC size > 2) and: [ (aMsgOC at: 3) isNil not] ) ifTrue: [ lastBleValueRxed := (aMsgOC at: 3) at:1 ]  . " note left as a string"

mySM signal: 'bleRx_',cmd.! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 14:21'!
bleTx: anOC

myCC ifNil:		[ self findCCs do: [ :aCC | self sendToCC: aCC message: (anOC) ]  ]   
	 ifNotNil:	[ self sendToCC: myCC message: (anOC) ] .

((anOC at:1) = 'IunjoinedYou' ) ifTrue: [ self removeMyCC  ].
! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:42'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 16:11'!
initialize 
super initialize .
myCC := nil! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/10/2014 13:04'!
myTXer
^myTXer! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/10/2014 13:04'!
myTXer: aTX
myTXer := aTX! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:30'!
myType
^myType ! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:30'!
myType: aString 
myType := aString! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/25/2014 10:41'!
removeMyCC
myTXer clearTarget.
myCC := nil! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 14:40'!
sendToCC: aCC message: inOC
| blob anOC |
" send a basic message to a particular cc if known use the TXer if not directly"
anOC := OrderedCollection newFrom: inOC .
anOC addFirst: myName .

((myTXer ~= nil)  and: [ (myTXer target) ~=nil ] ) ifTrue:  [ myTXer send: anOC ] 

ifFalse:  [ 
	blob := IAN_message new.
	self owner addMorphCentered: blob .
	blob setBarrierList .
	blob startPosition: self center.
	blob targetPosition: aCC center.
	blob target: aCC.
	blob message: anOC ]

! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 13:48'!
acceptDroppingMorph: aMorph event: evt 
| firstState |
" we only accept statemachines from the hand see wantsDropped"
self addMorph:  aMorph .
mySM := aMorph.
aMorph position: (self position).
aMorph inNode: true.

" find and follow first INITIAL including any action to get activeState setup"
	firstState :=  (self mySM chaseDwnInitial: (mySM stateChart ) ).
	firstState active: true.
	(mySM stateChart) activeState: firstState.
^true
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 14:34'!
changeName: aNum 
" use our name and add a counter (num) as a unique"
| subs t ourType|
ourType := self myType.
"find our text submorph"
subs := self submorphs .
subs isEmpty ifTrue:  [ "no name yet" 
					t := StringMorph new contents: (ourType asString,' ',aNum asString) . 
					self  addMorphCentered: t .
					
					self myName: (ourType asString,' ',aNum asString)
					]
		   ifFalse: [ "find the text morph and change its contents" 
					t := subs select: [  :aSubMorph | aSubMorph class = StringMorph  ].
					( t at: 1 ) contents:  (ourType asString,' ',aNum asString) .
					( t at: 1) center: (self center).
					self myName:  (ourType asString,' ',aNum asString) 
			         ]

! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:36'!
changeTime: aTime 
"tell our clock to get a new time"
myClock ownTime: aTime! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 17:07'!
checksDo: anOC 
" today theres only one check"
((self myENs) size = 8) ifTrue: [ ( self mySM )signal: 'tooManyENs' ] ifFalse: [  ( self mySM )signal: 'cntOK' ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 13:41'!
counters
^counters! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:50'!
countersDo: pEoE
| newCntr  cntNam |

cntNam := (pEoE at: 2) at: 1 .

counters at: cntNam ifPresent:   [ :cnt |
	" counter already there so perform"
	((pEoE at: 1) = 'load') ifTrue: [ cnt do_load: ((pEoE at: 2) at: 2) . ] ifFalse: [cnt perform: (pEoE at: 1) asSymbol ] 
	 ] 
	ifAbsent: [ 
	"make new counter from load message"
	newCntr := IAN_counter new.
	newCntr mySM: (self mySM).
	newCntr name: cntNam .
	newCntr do_load: ((pEoE at: 2) at: 2) .
	counters at: cntNam put: newCntr
	 ] ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/2/2014 19:54'!
extent: aPoint
"over ride for largest not smallest"
	| size oldRotationCenter |
	oldRotationCenter := self rotationCenter.
	size := aPoint x max: aPoint y.
	super extent: size @ size.
	self rotationCenter: oldRotationCenter.! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:35'!
findCCs
"ask my owner morph for the cc morphs"
| allCCs |

allCCs := self owner submorphs.
allCCs := allCCs select: [  :type | type class = IAN_CC ].

^allCCs ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/10/2014 13:21'!
findENs
"ask my owner morph for the en morphs"
| allENS |

" find the ENs we are connected to"
allENS := self myENs keys  . " set of the keys"

^allENS ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:38'!
findMoreLikeYou
	self class = IAN_EN
		ifTrue: [ self findENs ]
		ifFalse: [ self findCCs ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 09:35'!
flashOnOff: aBoolean
flashMorph visible: aBoolean
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 09:42'!
flashingSchedule
^flashingSchedule! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 16:49'!
flashingSchedule: type

" setsup an Array which has numbers which are the time per sec (in 5 divs) to turn on"
(type = 'flashTop') ifTrue: [ flashingSchedule := #(1 2 3) ].
(type = 'flashBot') ifTrue: [ flashingSchedule := #(6 7 8) ].
(type = 'flashRap') ifTrue: [ flashingSchedule := #(1 2 3 6 7 8) ].
(type = 'flashOff') ifTrue: [ flashingSchedule := #(11) ].  "11 will never be seleccted in a mod 10 counter"
^#(11)! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:53'!
hasClock
^true! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 11:39'!
hasStateMach
^hasStateMach! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 11:36'!
hasStateMach: aBol 
hasStateMach := aBol! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:00'!
inField
^inField! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 23:09'!
inField: aBoolean 
inField := aBoolean! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/15/2014 14:13'!
initialize
	| t pos  |
	super initialize.
	self inField: false.
	pos := self position + (30 @ 39).
	myClock := IAN_clock new.
	myClock position: pos.
	myClock bounds: (pos extent: 45 @ 25).
	self addMorph: myClock.
	myClock setOwner.
	counters := Dictionary  new.
	wiggle := 0.
	leftright := 1.
	hasStateMach := false .
	t := StringMorph new contents: (self class asString).
	self addMorphCentered: t .
	" flash morph"
	flashMorph  := PolygonMorph new.
	flashMorph vertices:  { (0@25).(25@50).(0@75).(25@75).(25@100).
	(50@75).(75@100).(75@75).(100@75).(75@50).(100@25).
	(75@25).(75@0).(50@25).(25@0).(25@25) } color: (Color yellow alpha: 0.5) borderWidth:  3 borderColor: Color black ;
		beStraightSegments .
	self addMorph: flashMorph .
	flashMorph hide.  "wait to flashon "
	self flashingSchedule: 'flashOff' .
	registers := Dictionary new.
	self stopStepping .! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 17:11'!
lastBleValueRxed
^lastBleValueRxed! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 09:56'!
mouseDown: evt
	evt controlKeyPressed
		ifTrue: [ World primaryHand attachMorph: self copy ]
		ifFalse: [ 
			evt shiftPressed
				ifTrue: [ 
					inField
						ifTrue: [ 
							wiggle := 1.
							self startStepping.
							myClock startStepping.
							] 
						]
				ifFalse: [ "" ] ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:33'!
myClock
^myClock! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/31/2014 20:12'!
myName
^myName! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/2/2014 20:05'!
myName: aString

myName := aString .
^self ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 13:50'!
mySM
^mySM
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/27/2014 17:21'!
push
mySM signal: 'push'! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/15/2014 20:26'!
registersDo: pEoE
| newReg  regNam |

regNam := (pEoE at: 2) at: 1 .

registers at: regNam ifPresent:   [ :reg |
	" register already there so perform"
	((pEoE at: 1) = 'saveTimePlus') ifTrue: [ reg value:  (myClock myTime +( (pEoE at:2) at: 2) asInteger)  ]
	 ] 
	ifAbsent: [ 
	"make new counter from load message"
	newReg := IAN_counter new.
	newReg mySM: (self mySM).
	newReg name: regNam .
	newReg value:  (myClock myTime + ((pEoE at:2) at: 2 )asInteger) .
	registers at: regNam put: newReg
	 ] 
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:57'!
repelsMorph: aMorph event: evt 
^ (self wantsDroppedMorph: aMorph event: evt) not! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/12/2014 15:05'!
running
^running! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/12/2014 15:05'!
running: bol
running := bol! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 15:39'!
setClockToMyTime: time
self myClock ownTime: time! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:28'!
step
	self inField
		ifTrue: [ 
			(wiggle between: 1 and: 6)
				ifTrue: [ 
					leftright := leftright * -1.
					self position: self position - ((leftright * 5) @ 0).
					wiggle := wiggle + 1 ]
				ifFalse: [ 
					wiggle = 7
						ifTrue: [ 
							self hasStateMach
								ifTrue: [ mySM signal: 'push' ] ].
					wiggle := 8 ]	" wiggle holds at 8" ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 12:05'!
stepTime
^100! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 11:37'!
wantsDroppedMorph: aMorph event: evt 

((aMorph class = IAN_stateMachine)  and: [(self inField) and: [aMorph hasStates]] )

 ifTrue:  [ self hasStateMach: true. ^true ]
 ifFalse: [^false ]

! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 16:46'!
wiggle
^wiggle! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 15:17'!
wiggle: aVal 
wiggle := aVal! !

BorderedMorph subclass: #IAN_bleTxer
	instanceVariableNames: 'myWaitingMessages conn_period target place newConnPeriod conPeriodChangeCounter holdMsg pendingClear strtPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 11:09'!
clearTarget
pendingClear := true. ! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 16:41'!
connPeriodDefault
"reset connection period to default"
conn_period := 2000 . " 2 seconds"! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/10/2014 12:53'!
connPeriodShort
"reset connection period to default"
conn_period := 50 . " 50mS seconds"! !

!IAN_bleTxer methodsFor: 'accessing' stamp: 'PhilipHunt 3/5/2014 16:42'!
conn_period
	^ conn_period! !

!IAN_bleTxer methodsFor: 'accessing' stamp: 'PhilipHunt 3/5/2014 16:42'!
conn_period: anObject
	conn_period := anObject! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/24/2014 14:43'!
draw
| height |
	height := 8 + (myWaitingMessages size *8) .
	self extent: ( 8 @ height) .
! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 11:08'!
initialize 
super initialize .
conn_period := 50 . " set a fast connection period at first"
myWaitingMessages := OrderedCollection new.
conPeriodChangeCounter := -1 . "counts down to change negative means no pending change"
pendingClear := false.! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/9/2014 10:12'!
newConnPeriod: aValue
newConnPeriod :=aValue! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/16/2014 20:09'!
place
^place! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/16/2014 20:09'!
place: aNumber
place := aNumber! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/24/2014 14:36'!
send: inOC 
| aMsgOC |

aMsgOC := OrderedCollection newFrom: inOC .

" myname type value (optional)"

((aMsgOC at: 2) = 'conPeriodChanged') ifTrue: [
	conPeriodChangeCounter := 6.
	holdMsg := aMsgOC .
	holdMsg at:2 put:  'conPeriodChange'. "recombine with slightly different message (prevent recursion in send)"
	self newConnPeriod: (((holdMsg at: 3) at: 1) asInteger ).
	self color: Color black ] 
ifFalse: [ 
	myWaitingMessages addLast: aMsgOC .
	self position: ((self position ) - ( 0 @ 8) ). " move upwards 8 for each added message"
	self draw .
	self color: Color red ]! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/24/2014 14:42'!
step
| newMessage |
" con period changes after 6 old periods"
conPeriodChangeCounter >= 0 ifTrue: [ 
	conPeriodChangeCounter := conPeriodChangeCounter -1 .
	conPeriodChangeCounter = 0 ifTrue: [ 
		target changeTime: (self owner myClock myTime). "IMPLICIT time sync CC to target EN" 
		self conn_period: newConnPeriod .
		self send: holdMsg
		 ]
	 ] .

"time messages and send them if possible"

(myWaitingMessages size ~= 0) ifTrue: [ 

	newMessage := IAN_message  new.
	newMessage message: (myWaitingMessages first) . 
	myWaitingMessages removeFirst . " message now off the queue"
	self position: ((self position ) + ( 0 @ 8) ). " move downwards 8 for each removed message"	
	self draw.
	self owner addMorphCentered: newMessage . "owner is CC or EN"
	newMessage setBarrierList .
	newMessage startPosition:  self center.
	newMessage targetPosition: target center.
	newMessage target: target .

	(myWaitingMessages size = 0) ifTrue: [ self color: Color lightCyan .
		"see if we remove this EN and so ourselves as a TXer" 
		 ].
	newMessage startStepping 
] ifFalse: [ pendingClear ifTrue: [  target := nil .  pendingClear := false. self visible: false ] ]! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/24/2014 14:39'!
stepTime 
^conn_period ! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 18:05'!
target
^target! !

!IAN_bleTxer methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/10/2014 13:07'!
target: aString 
| aCCorEN type sp |
sp := Character space .
type := (aString findTokens: sp) at: 1 .
type = 'EN'  ifTrue: [  aCCorEN := ((self owner) owner) submorphs detect: [ :aM | aM class = IAN_EN and: [ aM myName = aString ] ] ] .
type = 'CC' ifTrue: [  aCCorEN := ((self owner) owner) submorphs detect: [ :aM | aM class = IAN_CC and: [ aM myName = aString ] ] ] .
target := aCCorEN ! !

BorderedMorph subclass: #IAN_state
	instanceVariableNames: 'name exit entry document num initialTran myOC active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 10:38'!
active
^active! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 09:29'!
active: aBol
active := aBol.
active ifTrue: [ self borderColor: Color blue ; borderWidth: 3 ] ifFalse: [ self borderColor: Color black ; borderWidth: 1]! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 3/3/2014 14:36'!
addEntry: atext
entry := atext .
! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 3/3/2014 14:36'!
addExit: atext
exit := atext .
! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 20:03'!
breakActionUp: anAction
| sp tab  temp type selector values|

sp := Character space.
tab := Character tab.
" form of input is type_selector(value,value); "
"first remove whitespaces and colon"

temp := anAction reject: [ :letter | (letter = sp) or: [ (letter = tab)  or: [ letter = $; ] ]  ].

temp := temp findTokens: $_ .
type := temp at: 1.
temp := (temp at: 2) findTokens: {$( . $) } .
selector := temp at: 1.
temp removeFirst . " selector removed"
(temp size > 0) ifTrue: [ values :=( (temp at:1 ) findTokens: $, ) ].  " leaves values as anOC of strings"

^ (OrderedCollection  with: type with: selector with: values)! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/8/2014 10:37'!
doEntry: anEntry
"doEntry decomposes entry into an array for doing"
^self breakActionUp: anEntry! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/8/2014 10:24'!
doExit: anExit
"doExit decomposes exit into an array for doing"

^self breakActionUp: anExit! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 10:24'!
entry
^entry! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 10:24'!
exit
^exit! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 15:12'!
fillDataWith: anOC 
| my_glyph val i str  |
" read strings into inst vars until endOc (=/px) seen "
myOC := anOC.
" lookfor glyph"
str := self className .
"drop IAN_"
str := str copyFrom: ('IAN_' size + 1) to: (str size).
my_glyph := (str,'_glyph')  asOrderedCollection . " example state_glyph"

i := 1.

val :=( myOC at: i) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i) size)).  " step thru top level of ordered collection"

[(val  = my_glyph) or: [ i = (myOC size) ] ] whileFalse: [  val :=( myOC at: (i := i +1) ) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i ) size)) ].

val := myOC at: i . " get full token back"
"found <state_glyph node=aString/>"
" aString is double quted and holds x,y,a,b x,y is start point and a,b is end point "
" find double quote poisitions in collection"
self myglyph: val  .

" try to find entry and exit"
entry := nil.
exit := nil.

1 to: (myOC size -2 ) do: [ :indx | entry ifNil: [ entry := self findIn: myOC at: indx  between: 'entry'].
							   	   exit   ifNil: [ exit   := self findIn: myOC at: indx  between: 'exit'  ]   ].


! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 15:13'!
findIn: anOC at: index between: aName 
| srt end |

srt :=  (anOC at: index) = (aName asOrderedCollection) .
end := (anOC at: (index +2)) = (('/',aName) asOrderedCollection) .
(srt and: [ end] )
	ifTrue: [ ^String newFrom: ((anOC at: (index +1)) asArray )].
	^nil.! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 10:39'!
initialize 
super initialize .
self color: Color lightGreen .
self useRoundedCorners .  "position: self position + (20 atRandom @ 30 atRandom)"
self active: false.! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 11:23'!
myglyph: val 
| i firstQ secondQ arg startX startY endX endY start end ss |
i := 1.
[(val at: i) = $" ] whileFalse: [ i := i+1 ] . firstQ := i. i:= i+ 1. "skip that one"
[(val at: i) = $" ] whileFalse: [ i := i+1 ] . secondQ := i.
" each can be one or two or three or more digits as character"  
i  := 1. arg := 0 .
[ (val at: firstQ+ i) = $, ] 			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. startX := arg .
i := i+ 1. " skip"
arg := 0.
[ (val at: firstQ+ i) = $, ] 			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. startY := arg . 
i := i+ 1. " skip"
arg := 0.	
[ (val at: firstQ+ i) = $, ] 			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. endX := arg . 
i := i+ 1. " skip"
arg := 0.			
[ (firstQ+ i) = secondQ ]			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. endY := arg . 	
				
				
			start := (startX @ startY) . start :=  start * 4. "crude scale"
			end := (endX @ endY) .	 end := end * 4.
			self position: start  . self extent: end.
			
		
			
		" for each sub morph move them back our position"
		self submorphsDo: [  :each | each position: each position - start ].
		ss :=  (StringMorph contents: name) .
		ss position: (self topCenter + ((ss width //2) negated  @ 3 )).
		self addMorph: ( ss ).	! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 1/28/2014 13:38'!
name
^name! !

!IAN_state methodsFor: 'actions' stamp: 'PhilipHunt 2/10/2014 10:49'!
name: aString
name := aString
! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 10:23'!
num
^num! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 2/10/2014 10:50'!
num: anInteger 
num := anInteger! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/24/2014 17:06'!
varData: nx
	" rip off the end of the token"

	" utility only "

	| i type val firstsp firstdQ |
	i := 1.
	(nx includes: $=)
		ifTrue: [ 
			[ (nx at: i) = (Character space) ] whileFalse: [ i := i + 1 ].
			firstsp := i.
			[ (nx at: i) = $" ] whileFalse: [ i := i + 1 ].
			firstdQ := i.
			type := nx copyFrom: firstsp +1 to: firstdQ - 2.
			i := 1.
			[ (nx at: firstdQ +1 + i) = $" ] whileFalse: [ i := i + 1 ].	"+1 moves over  first doublequote finds next doublequote"
			val := nx copyFrom: firstdQ + 1 to: firstdQ + i .
			^ Array with: type asArray with: val asArray ]. ! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:41'!
yourtitleData: anArray

|  args |

args := String newFrom: ((anArray at: 2) asArray ).

self name: args .
! !

BorderedMorph subclass: #IAN_stateChart
	instanceVariableNames: 'document srcFileName name srcTokens positionInTokens activeState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

IAN_stateChart class
	instanceVariableNames: 'srcTokens'!

IAN_stateChart class
	instanceVariableNames: 'srcTokens'!

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 13:30'!
activeState
^activeState ! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 09:22'!
activeState: newState
activeState := newState.
newState active: true.! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:10'!
document
^document! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:09'!
document: aString 
document := aString! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 16:15'!
fillDataWith: anOC 
" read strings into inst vars until endOc (=/px) seen "
| myOC |
myOC := anOC! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/20/2014 16:25'!
initialize 
super initialize .
self color: Color lightCyan   .
! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 15:10'!
makeStartingAt: startOcToken onMorph: aMorph
	" recursive decent is implicit for state elements"

	" we read the src tokens and make new element for each token at the same level recurse for those that are themselves states"

	| nx px newMorph s z end  xy statenum |

	statenum := 0.
	
	end := '/' , (self shortName: startOcToken).
	(startOcToken includes: $=)
		ifTrue: [ aMorph yourtitleData: (aMorph varData: startOcToken) ].	"for some this is name=, others have other forms"
			
	px := self shortName: startOcToken .
	z := OrderedCollection new.
	
	[ px = end ]
		whileFalse: [ 
			nx := self nextToken.
			px := self shortName: nx.
			(px = 'state_diagram')
			 ifFalse: [ 
				(#('state' 'tran' 'initial' 'choice') inject: false into: [ :sofar :each | sofar or: [ each = px ] ])
					ifTrue: [ 
						s := 'IAN_' , px.
						newMorph := (Smalltalk at: s asSymbol) new. 
						(px = 'state') ifTrue: [ newMorph num: statenum. 
												aMorph addMorphBack: newMorph. ]
									 ifFalse: [ 	aMorph addMorphFront: newMorph  ].
						(px = 'state') | (px='tran') | (px = 'initial') ifTrue: [ statenum := statenum + 1 ] .
						self makeStartingAt: nx onMorph: newMorph
						 ].
					z addLast: nx 
					]
			ifTrue: [ xy :=  ((((String newFrom: nx asArray) findTokens: $" ) at:2) findTokens: $,) collect: [  :e | e asInteger  ]. xy := xy *4 . "same crude scale"
					self extent: ( (xy at: 1) @ (xy at: 2)) ; position: (0 @ 0)].
			].
	aMorph fillDataWith: z! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 11:37'!
makeStartingAtTop
| firstOcToken |

positionInTokens := 1 .
firstOcToken :=  self nextToken.
self makeStartingAt: firstOcToken onMorph: self .

self submorphsDo: [  :each | each position: each position - (self position) ].

! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:09'!
name
 ^name! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:08'!
name: aString
name := aString! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 16:12'!
nextToken
| nx |
(positionInTokens > srcTokens size) ifTrue: [ ^nil ].
nx := self srcTokens at: positionInTokens .
positionInTokens := positionInTokens +1.
^nx! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 13:22'!
shortName: nx
	" utility only "
	| i px |
	i := 1.
	nx addLast: (Character space) .  "add space to end makes stop condition same either way"
	[ (nx at: i) = Character space ] whileFalse: [ i := i + 1 ].
	nx removeLast . " take it off again"
	px := nx copyFrom: 1 to: i - 1.
	^ String newFrom: px asArray! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:11'!
srcFileName
^srcFileName ! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:10'!
srcFileName: aFile 
srcFileName := aFile ! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 14:28'!
srcTokens
^srcTokens! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:52'!
srcTokens: anOC 
srcTokens := anOC ."an ordered collection of tokens"! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 14:20'!
varData: nx
	" rip off the end of the token"

	" utility only "

	| i type val firstsp firstdQ |
	i := 1.
	(nx includes: $=)
		ifTrue: [ 
			[ (nx at: i) = (Character space) ] whileFalse: [ i := i + 1 ].
			firstsp := i.
			[ (nx at: i) = $" ] whileFalse: [ i := i + 1 ].
			firstdQ := i.
			type := nx copyFrom: firstsp +1 to: firstdQ - 2.
			i := 1.
			[ (nx at: firstdQ +1 + i) = $" ] whileFalse: [ i := i + 1 ].	"+1 moves over  first doublequote finds next doublequote"
			val := nx copyFrom: firstdQ + 1 to: firstdQ + i .
			^ Array with: type asArray with: val asArray ]. ! !

Morph subclass: #IAN_clock
	instanceVariableNames: 'myTime myJobs textTime myParentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 16:36'!
handlesMouseDown
^ false! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/3/2014 17:24'!
initialize 
| |
super initialize .
"appearence"
self color: Color lightBrown .
textTime := StringMorph new contents: ( myTime asString) .
textTime position: (self position + (12@5)).
self addMorph: textTime.

myJobs := OrderedCollection  new.
myTime := 0.
self stopStepping ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:04'!
mouseDown: evt
evt shiftPressed ifTrue: [ (self isStepping) ifTrue: [ self stopStepping  ] ifFalse: [ self startStepping  ] ]! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 21:25'!
myTime
^myTime ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 17:43'!
ownTime: aTime 
" move up any jobs in queue too watch roll over"

myJobs do: [ :aJob | aJob actionTime: (((aJob actionTime) + aTime - myTime) \\ 10000 )]. 
myTime := aTime! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 14:57'!
setClockToMytime: aVal 
self ownTime: aVal ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/3/2014 17:43'!
setOwner
myParentNode := self owner.! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:34'!
setupJobat: aTime for: aReceiver selector: aSelectorString toGet: anArray 
myJobs addLast: ((IAN_job new) atTime: aTime give: aReceiver selector: aSelectorString message: anArray )! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 17:25'!
signalMeAt: timeAndAction
" arg is an OC with two strings at thsi point"
| time |
time :=  (timeAndAction at:1) asInteger. 
time := time \\ 10000.
self setupJobat: time for: (myParentNode mySM) selector: ('signal:' asSymbol )toGet: (timeAndAction at: 2) ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 17:13'!
signalMeAtLastRXedTime: timeAndAction
" arg is an OC with two strings at thsi point"
| time |
time := myParentNode lastBleValueRxed asInteger.
time := time \\ 10000.
self setupJobat: time for: (myParentNode mySM) selector: ('signal:' asSymbol )toGet: (timeAndAction at: 1) ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 17:24'!
signalMeIn: timeAndAction
" arg is an OC with two strings at thsi point"
| newTime |

newTime := myTime + (timeAndAction at: 1) asInteger.

timeAndAction at: 1 put: (newTime printString ).
" now same as absolute time"
self signalMeAt: timeAndAction ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/28/2014 13:31'!
step
| toDoes whatToDoForFlash |
myTime := (myTime + 1) \\ 10000.
textTime contents: ( myTime asString) .

" now see if there are call backs to do"
toDoes := myJobs select: [  : aJob | (aJob actionTime = myTime)  ]. " find the ones due now"

toDoes do: [ : thisToDo | "send the actiontoDoes "
	thisToDo actionReceiver perform: (thisToDo actionSelector) with: (thisToDo actionMessage )   . "perform: with:"
	myJobs remove: thisToDo . ].

" here we do flashing control "
whatToDoForFlash := (owner flashingSchedule ) anySatisfy: [  : ontime | ontime = (  myTime \\ 10)] .	
owner flashOnOff: whatToDoForFlash .! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/27/2014 14:34'!
stepTime
 ^100! !

Morph subclass: #IAN_fieldMorph
	instanceVariableNames: 'numCCs numENs running wereRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:15'!
acceptDroppingMorph: aMorph event: evt 
| num |

(aMorph class= IAN_barrier ) ifTrue: [  self addMorphBack:   aMorph ] ifFalse: [ self addMorph: aMorph ].
aMorph stopStepping .
"aMorph wiggle: 0 ."
(aMorph class = IAN_CC) ifTrue: [  num := (self numCCs: (self  numCCs + 1)). aMorph changeName: num] .
(aMorph class = IAN_EN)  ifTrue: [  num := (self numENs:  (self  numENs  + 1)). aMorph changeName: num] .

" give its clock a randome number"
aMorph hasClock ifTrue: [aMorph changeTime: 5000 atRandom].

aMorph inField: true .
^true! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:14'!
hasNoPartsYet
numCCs := 0.
numENs  := 0
! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:14'!
numCCs
^numCCs! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:16'!
numCCs: aVal 
^numCCs := aVal! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:15'!
numENs
^numENs! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:16'!
numENs: aVal 
^numENs := aVal! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/13/2014 14:41'!
pauseRun
" tell all morphs below me to stop their clocks if they were running - remember which were running to restart them"
	| all |
	all := self allMorphs.
	(self running)
		ifTrue: [ 
			wereRunning := OrderedCollection new.
			all do: [ :each | (each isStepping) ifTrue: [ each stopStepping. wereRunning add: each ]  ].
			self running: false ]
				
		ifFalse: [ 
			wereRunning do: [  :each | each startStepping  ].
			self running: true ]! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:52'!
repelsMorph: aMorph event: evt 
^ (self wantsDroppedMorph: aMorph event: evt) not! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/12/2014 15:44'!
running
^running! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/12/2014 15:44'!
running: aBol
running := aBol! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 15:03'!
wantsDroppedMorph: aMorph event: evt 
"^((aMorph class = IAN_EN) or: [ (aMorph class = IAN_CC) or: [aMorph class = IAN_stateMachine] ])"
^true "for testing time"
! !

Morph subclass: #IAN_partsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_partsMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 12:22'!
acceptDroppingMorph: aMorph event: evt 
self addMorph:  aMorph .
aMorph inField: false .
aMorph stopStepping .
^true! !

!IAN_partsMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 13:33'!
wantsDroppedMorph: aMorph event: evt 
| aClass |
aClass := aMorph class.
^((aClass = IAN_Node) or: [ (aClass = IAN_barrier ) or: [aClass = IAN_stateMachine ] ]).! !

Object subclass: #IAN_Space
	instanceVariableNames: 'window fieldMorph partsMorph logMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_Space methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/12/2014 15:49'!
initialize 

super initialize.
window:=StandardWindow labelled: 'IAN_Space'.
fieldMorph := IAN_fieldMorph new.
window
      addMorph: fieldMorph
      fullFrame: (LayoutFrame
          fractions: (0.2@0 corner: 1@1)
          ).
fieldMorph color: Color lightGray .
fieldMorph hasNoPartsYet.
fieldMorph running: true.

partsMorph := IAN_partsMorph new.
window
      addMorph: partsMorph
      fullFrame: (LayoutFrame
          fractions: (0@0 corner: 0.2@1)
         ).
partsMorph color: Color veryLightGray .


  window openInWorld.
  self stage.
^self! !

!IAN_Space methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/12/2014 15:43'!
stage
| aCC anEN aStateMachine aBarrier|
" this method places element on to the IAN space"
aCC := (IAN_CC new) .
aCC myType: 'CC' .
aCC stopStepping .
aCC color: Color lightRed ; borderWidth: 2 ; useRoundedCorners .

anEN := (IAN_EN new).
anEN myType: 'EN' .
anEN color: Color lightGreen ; borderWidth: 2 ;useRoundedCorners .


aBarrier := IAN_barrier  new.
aBarrier verticesAt: 1 put: (0 @ 0).
aBarrier verticesAt: 2 put: (0 @25).
aBarrier verticesAt: 3 put: (25 @25).
aBarrier verticesAt: 4 put: (25 @0).
aBarrier beStraightSegments ; showOrHideHandles.
aBarrier dropRate:  0.5 .


partsMorph addMorphCentered: aBarrier.
partsMorph addMorphCentered: aCC . aCC stopStepping. 
partsMorph addMorphCentered: anEN . anEN stopStepping .
anEN      position: (anEN position + (0@85)).
aBarrier position: (aBarrier position +(0@150) negated).

"now add state machine holders"
aStateMachine := (IAN_stateMachine new).
aStateMachine color: Color transparent  ; borderWidth: 2 ; extent: (15@15). 
partsMorph addMorphCentered: aStateMachine.
aStateMachine position: (aStateMachine position - (10@80)).
" second one to hold other machine"
aStateMachine := (IAN_stateMachine new).
aStateMachine color: Color transparent  ; borderWidth: 2 ; extent: (15@15). 
partsMorph addMorphCentered: aStateMachine.
aStateMachine position: (aStateMachine position - (-10@80)).

partsMorph addMorph: (SimpleButtonMorph new
                                           label: 'pause clock';
                                           target: fieldMorph ;
                                           actionSelector: #pauseRun;
							 position: partsMorph topCenter - (30@0) ).
fieldMorph running: true.



! !

Object subclass: #IAN_counter
	instanceVariableNames: 'name value mySM'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:44'!
dec
value := value - 1.
(value = 0) ifTrue: [ (self mySM )signal: (name,'_isZero'). ]! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 09:34'!
do_load: aString
"load complicates things"
(aString = 'lastBleValueRxed' ) ifTrue: [ self value: (self owner lastBleValueRxed asInteger) ]
							    ifFalse: [ self value: (aString asInteger) ]
! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 13:22'!
inc
value := value + 1! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 13:23'!
initialize 
super initialize .
value := 0! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 14:39'!
isNotZero
^(value ~=0)! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 14:38'!
isZero
^(value =0)! !

!IAN_counter methodsFor: 'accessing' stamp: 'PhilipHunt 3/7/2014 09:43'!
mySM
	^ mySM! !

!IAN_counter methodsFor: 'accessing' stamp: 'PhilipHunt 3/7/2014 09:43'!
mySM: anObject
	mySM := anObject! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 13:21'!
name
^name! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 13:21'!
name: aString 
name := aString! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 09:23'!
printOn: aStream
	^self value printOn: aStream base: 10! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 10:13'!
printString
^'aCounter ', name,' ', (value printString )! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 09:23'!
value 
^value! !

!IAN_counter methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/6/2014 20:42'!
value: aCount
value := aCount! !

Object subclass: #IAN_job
	instanceVariableNames: 'actionTime actionReceiver actionSelector actionMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:32'!
actionMessage
^actionMessage! !

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:31'!
actionReceiver
^actionReceiver! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 15:01'!
actionSelector
^actionSelector ! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:41'!
actionSelectorString: aStringToBeSymbol 
^aStringToBeSymbol  asSymbol! !

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:29'!
actionTime
^actionTime ! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 17:33'!
actionTime: newTime
actionTime := newTime .! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:43'!
atTime: aTime give: aReceiver selector: aSelectorString message: anArray
actionTime :=aTime.
actionReceiver := aReceiver.
actionSelector := self actionSelectorString: aSelectorString. "converts to symbol for us"
actionMessage := anArray! !

Object subclass: #IAN_register
	instanceVariableNames: 'name value mySM'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_register methodsFor: 'accessing' stamp: 'PhilipHunt 3/15/2014 14:30'!
mySM
	^ mySM! !

!IAN_register methodsFor: 'accessing' stamp: 'PhilipHunt 3/15/2014 14:30'!
mySM: anObject
	mySM := anObject! !

!IAN_register methodsFor: 'accessing' stamp: 'PhilipHunt 3/15/2014 14:30'!
name
	^ name! !

!IAN_register methodsFor: 'accessing' stamp: 'PhilipHunt 3/15/2014 14:30'!
name: anObject
	name := anObject! !

!IAN_register methodsFor: 'accessing' stamp: 'PhilipHunt 3/15/2014 14:31'!
value
	^ value! !

!IAN_register methodsFor: 'accessing' stamp: 'PhilipHunt 3/15/2014 14:30'!
value: anObject
	value := anObject! !

CircleMorph subclass: #IAN_message
	instanceVariableNames: 'startPosition targetPosition int barriersToPass message target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 19:52'!
barriersToPass
^barriersToPass ! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 19:53'!
barriersToPass: anArray 
barriersToPass := anArray
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 20:06'!
barriersToPassRemove: aB 
| tempArray |
tempArray := self barriersToPass reject: [ :B | B = aB ].
self barriersToPass: tempArray
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 20:09'!
initialize 
super initialize .
int:= 1.
self color: Color blue.
self extent: (8@8).
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:24'!
int: aVal
int := aVal! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 15:51'!
message
^message! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/10/2014 16:27'!
message: aMsgOC

message := aMsgOC! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 20:15'!
setBarrierList
self barriersToPass:  (self owner submorphs select: [ :aM | aM class = IAN_barrier ] )
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 16:48'!
startPosition
^startPosition! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 16:48'!
startPosition: aPos 
startPosition := aPos! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:21'!
startStepping
int := 1.
super startStepping ! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 16:51'!
step
	" go from present position towards target position in about 30 steps"
	(self position dist: targetPosition) >5
		ifTrue: [ 
			self position: startPosition + ((targetPosition - startPosition) * int // 40).
			int := int + 1.	" do we intersect with a barrier?"
			self barriersToPass
				do: [ :aB | 
					(aB containsPoint: self center)
						ifTrue: [ 
							aB statDel ifTrue: [ 	self delete.  ] ifFalse: [ self barriersToPassRemove: aB ]
								 ] ] ]
		ifFalse: [ 
			self stopStepping.
			message ifNotNil:  [target bleRx: message ].

			self delete.
			 ]	" in a HIT we also kill the Morp if statstics say yes"! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 16:40'!
stepTime 
^25! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 15:54'!
target: anotherNode 

target := anotherNode.! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 14:35'!
targetPosition
^targetPosition! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 14:34'!
targetPosition: aPosition 
targetPosition := aPosition ! !

CircleMorph subclass: #IAN_stateMachine
	instanceVariableNames: 'name stateChart inField inNode hasStates aWheel srcTokens signalQ smBusy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 21:43'!
aWheel: aVal 
^aWheel at: aVal! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/17/2014 17:04'!
actOn: somAct
| targetType myNode  entryOrExit  |
" act the condition at the SM level not the state level"
entryOrExit  := OrderedCollection newFrom: somAct. "don't alter the origial"
myNode := self owner.

entryOrExit ifNotNil:  [ 
	targetType  := (entryOrExit at: 1) . " a clock, flasher or ble etc."
	targetType := targetType asLowercase .

	(targetType = 'clock')   ifTrue: [  myNode myClock perform: ((entryOrExit at: 2),':') asSymbol withArguments: (Array with: (entryOrExit at:3) )  ] .
	(targetType = 'flasher')   ifTrue: [  myNode flashingSchedule:  (entryOrExit at: 2) ] .
	(targetType = 'bletx')      ifTrue: [  entryOrExit removeFirst .  myNode bleTx: entryOrExit ] .
	(targetType = 'counter')  ifTrue: [  entryOrExit removeFirst .  myNode countersDo: entryOrExit   ] .
	(targetType = 'register')  ifTrue: [ entryOrExit removeFirst .  myNode registersDo: entryOrExit  ] .
	(targetType = 'check')     ifTrue: [ entryOrExit removeFirst .  myNode checksDo: entryOrExit  ]
	" what about CC and EN private messages ?"
].


! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 09:21'!
changeActiveStateTo: aNewOne
	stateChart activeState active: false.
	stateChart activeState: aNewOne.

	
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/8/2014 11:03'!
chaseDwnInitial: presentState
| initialExists initT subs val st i aState |

st:= presentState .
aState := presentState .

initialExists := (presentState  submorphs detect: [ :aM | aM class = IAN_initial ] ifNone: [nil] ) .


initialExists ifNotNil: [
	initT := initialExists target . " do initial action and all entry actions"

	subs := aState submorphs select: [  :m | m class = IAN_state ].
	i := 1.
	(initT size - 1) timesRepeat: [ 
		val := (initT at: (i+1)) asInteger .
		st := subs detect: [ :each| each num = val ].
		(st entry) ifNotNil: [((st entry) findTokens: $;) do: [ :actE | self actOn:( st doEntry: actE ) ]].
		i := i + 1.
		subs := st submorphs select: [  :m | m class = IAN_state ].
		].
	aState := st .
	" see if action is filledin if so do it"
	(initialExists action) ifNotNil:  [self actOn: (initialExists doAction) ] ].

^aState! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 11:28'!
checkmeAndAboveForTran: aState signal: aSignal targetSoFar: aTarget
"look at the active state first then all its parents for one active trans then report it"
| target next ans |

target := self test: aState forTranSignal: aSignal .
"WORKING HERE THE target GETS WRAPPED TOO DEEP WITH aTarget in the return"

target ifNil: [ 
	next := aState owner.
	(next class = IAN_state) ifFalse: [ ^aTarget] "effectively returns the same empty ordColl we entered with"
							 ifTrue:  [ 
									  ans := self checkmeAndAboveForTran:  next  signal: aSignal targetSoFar: aTarget.
									  (ans size ~= 0) ifTrue:  [  aTarget addFirst: '..' .
															   ^aTarget ] . " we found it and can end search"
									  "we never found it answer zero in size"
									 ^aTarget ].
	 ] ifNotNil: [ aTarget addAll: target. ^aTarget  ] .

! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:31'!
doSignal: aSignal 
| possible newState |
" find out if this signal changes state"

possible := (OrderedCollection new) .
possible := self checkmeAndAboveForTran: (stateChart activeState) signal: aSignal  targetSoFar: possible .

(possible size ~= 0) ifTrue: [  "we found one to be done" 
	newState := self findTargetState: possible .
	self changeActiveStateTo: newState.
	]! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 16:44'!
findNextInOc: anOC starting: position
	" returns new collection with contents up to next separator"

	| separators endPos |
	separators := #($> $<). 
	endPos := position.
	[ separators inject: false into: [ :sofar :delim | sofar or: [ delim = (anOC at: endPos) ] ] ]
		whileFalse: [ endPos := endPos + 1 ].
	^ endPos! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/8/2014 11:02'!
findTargetState: aTarget 
| dwnstates presentState val st |
aTarget removeFirst . "one too many double dots"

" follow this transition to a new state - return that state"
presentState := self stateChart activeState.
" first take off each double dot and move UP, execute EXIT along the way"
[aTarget first = '..'] whileTrue: [ "do the exit move up one, remove this double dot"
	(presentState exit) ifNotNil:  [((presentState exit) findTokens: $;) do: [ :actE | self actOn:( presentState doExit: actE )] ].
	presentState := presentState owner.
	aTarget removeFirst .
	 ].

"then from first NUMbered element down execute ENTRY along the way"

[aTarget size ~= 0] whileTrue:  [
	val := (aTarget at: 1) asInteger .
	dwnstates := presentState submorphs select: [  :m | m class = IAN_state ].
	st:= dwnstates detect: [  :each | each num = val ].
	(st entry) ifNotNil: [((st entry) findTokens: $;) do: [ :actE | self actOn:( st doEntry: actE )] ]. 
	presentState := st .
	aTarget removeFirst.
	 ] .

" now find if theres an INIT and do that"
"initialize state active"

presentState := self chaseDwnInitial: presentState .

^presentState.
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:17'!
handlesMouseDown: evt 
^ true! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:17'!
hasStates
^hasStates! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:49'!
hasStates: aBoolean 
hasStates := aBoolean ! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:01'!
inField
^inField! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:02'!
inField: aBol
inField:= aBol! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:16'!
inNode
^inNode! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:16'!
inNode: aval
inNode := aval.! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:36'!
initialize
super initialize .
self inField: false.
self inNode: false.
self position: (0 @ 0).
self hasStates: false.
aWheel := Color lightCyan wheel: 8 .
signalQ := OrderedCollection new.
smBusy := false.
self startStepping . "and never stop?"! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/5/2014 11:55'!
makeStateFrom: aFile
	| aStream f endPos startPos outS outS2 lf cr  |
	lf := Character lf.
	cr := Character cr.	" we read and parse the file into states"	
	f := StandardFileStream readOnlyFileNamed: aFile.
	f findString: '<statechart'.
	startPos := f position.
	endPos := f findStringFromEnd: '</statechart>'.
	endPos := endPos + '</statechart>' size.	" now put that in a String we can stream over"
		
	f position: startPos.
	aStream := OrderedCollection new.
	[ f atEnd or: [ f position = endPos ] ] whileFalse: [ aStream add: f next ].
	f close.	
		" remove cr/lf from it"
	outS := aStream reject: [ :c | c = lf or: [ c = cr ] ].	
		"place the relevent file contents in the token class variable for  the recursion"
	stateChart := IAN_stateChart new. 
	outS2 := self parseStates: outS. 
	"make it invisible"
	stateChart srcTokens: outS2. 
	stateChart srcFileName: aFile.
	stateChart name: aFile.	"red for better name"
	stateChart hide.
	
	stateChart makeStartingAtTop.

" initial state chase happens only when dropped on a NODE (so action can happen !!)"
	stateChart position: (self position + (100@25)) .
	self addMorph: stateChart .
	self hasStates: true. 
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/4/2014 10:18'!
mouseDown: evt 
| aFile |
evt controlKeyPressed ifTrue: [ World primaryHand attachMorph: self copy . ] .

evt shiftPressed ifTrue: [
						aFile := (UIManager default chooseFileMatching: {'*.qm'} ).
						aFile ifNotNil: [ self makeStateFrom: aFile.
										stateChart visible: false.
										self color: (self aWheel: (aFile asString stringhash \\ 8) + 1)] ]
			ifFalse:  [ (hasStates & inNode )  ifTrue: [stateChart visible: (stateChart  visible not) ]]


! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/28/2014 15:17'!
name
^name! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/28/2014 15:17'!
name: aString
name := aString.! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 16:43'!
parseStates: anOC
	| pos atok allspaces result |
	
	result := OrderedCollection new.
	pos := 2. "first char is always $<"
	
	[ pos < anOC size ]
		whileTrue: [ 
			atok := anOC copyFrom: pos to: (self findNextInOc: anOC starting: pos) - 1.
			pos := pos + (atok size) +1. 
			allspaces := atok inject: true into: [ :sofar :ch | sofar and: [ ch = Character space ] ].
			allspaces
				ifFalse: [ result addLast: atok ] .				].
	^result 
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:39'!
signal: aSignal 
signalQ addLast: aSignal.

! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 19:44'!
stateChart
^stateChart ! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:38'!
step 
smBusy ifFalse: [ 
	(signalQ size ~= 0) ifTrue: [ smBusy := true. 
								self doSignal: (signalQ removeFirst) .
								smBusy := false. ]
	] .! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 11:33'!
stepTime 
^100 " we will try to take in new signals on this tick"! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 3/7/2014 17:21'!
test: aState forTranSignal: aSignal
" look into this state and see if this has an active transition which activates a new state"
| trans activeTran |

trans :=aState submorphs select: [ :aM | aM class = IAN_tran ].
activeTran := trans detect: [ :each | (each trigger) = aSignal ] ifNone: [ ^nil].
" special condition for trget to self which is just dot dot"

(((activeTran target size) = 1) and: [ ((activeTran target at: 1) = '..') ])
		 ifTrue: [ activeTran target addLast: '..' . activeTran target addLast: (aState num)  ] .

^activeTran target
! !
